#ifndef __ListenerLlums_H__
#define __ListenerLlums_H__

#include "Ogre.h"
#include "OgreLogManager.h"
#include <OgreMovableObject.h>

class ListenerLlums : public MovableObject::Listener
{
public:
	/// Standard constructor
    ListenerLlums(GeneradorArbre * tree)
    {
		arbre = tree;
    }

	const LightList * objectQueryLights(const MovableObject * objecte) {

		//std::deque<ParellaLlums*> llistaNodesLlums = calcularCut(objecte,arbre->getArrel());

		//LightList * a = obtenirLlumsRepresentants(llistaNodesLlums);

		LightList * a = new LightList();
		//ColourValue c1 = ((Entity*)objecte)->getSubEntity(0)->getMaterial()->getBestTechnique(0)->getPass(0)->getDiffuse();
		//a->push_back(&arbre->getLlum(0));
		//equacioRadiancia(objecte,arbre->getArrel());

		return a;
	}

	std::deque<ParellaLlums*> calcularCut(const MovableObject * objecte, ParellaLlums * node){
	//Calcula el cut de llums per una entitat "objecte" donada una parella de llums "node"
		std::deque<ParellaLlums*> cutActual;

		
		Real cota = calcularCota(objecte,node);
		Real resEqRadiancia = equacioRadiancia(objecte,node);
		std::deque<ParellaLlums*> fillsEsquerra;
		std::deque<ParellaLlums*> fillsDreta;
		std::deque<ParellaLlums*> llistaFills;// = new deque<ParellaLlums*>();
		
		if (cota > (resEqRadiancia*0.02)) {
		//CONTINUAR
		//if (/*((rand()*1000)%2 == 0)&&*/(node->fillEsq() == NULL && node->fillDreta() == NULL)){
		//Obtenim els fills de l'esquerra i els de la dreta (2 crides recursives)
			if (node->fillEsq() != NULL)
				fillsEsquerra = calcularCut(objecte,node->fillEsq());
			if (node->fillDreta() != NULL)
				fillsDreta = calcularCut(objecte,node->fillDreta());

			//Els juntem en una mateixa llista
			for (uint i=0;i<fillsEsquerra.size();i++) llistaFills.push_back(fillsEsquerra[i]);
			for (uint z=0;z<fillsDreta.size();z++) llistaFills.push_back(fillsDreta[z]);

			return llistaFills;
		}
		else {
		//Nomes retornem el node actual dins de la llista
			llistaFills.push_back(node);
			return llistaFills;
		}
	}

	Real calcularCota(const MovableObject * objecte, ParellaLlums * node){
	//Donat un objecte determinat i un node de llums, calculem la seva cota maxima
		//
		ColourValue colorMaterial = objecte->getParentSceneNode()->getMaterial()->getBestTechnique(0)->getPass(0)->getDiffuse();

		return 0;
	}

	Real equacioRadiancia(const MovableObject * objecte, ParellaLlums * node){
	//Donat un objecte determinat i un node de llums, calculem la seva equacio de raciancia
	//Material x Geometria x Visibilitat x Intensitat
		//Material
		ColourValue colorMaterial = objecte->getParentSceneNode()->getMaterial()->getBestTechnique(0)->getPass(0)->getDiffuse();
		//Geometria

		//Visibilitat = 1
		return 0;
	}

	LightList * obtenirLlumsRepresentants(std::deque<ParellaLlums*> lightCut){
	//Obtenim les llums (objectes "Light") del cut "lightCut"
		LightList * llistaLlums = new LightList();
		for (uint i=0;i<lightCut.size();i++){
			llistaLlums->push_back(&(arbre->getLlum(lightCut[i]->llumRepresentant())));
		}
		return llistaLlums;
	}

protected:
	GeneradorArbre * arbre;
};

#endif
