#ifndef __ListenerLlums_H__
#define __ListenerLlums_H__

#include "Ogre.h"
#include "OgreLogManager.h"
#include <OgreMovableObject.h>
#include "ExampleApplication.h"

class ListenerLlums : public MovableObject::Listener
{
public:
	/// Standard constructor
    ListenerLlums(GeneradorArbre * tree)
    {
		arbre = tree;
    }

	ListenerLlums(GeneradorArbre * tree, SceneManager * manager, bool act)
    {
		arbre = tree;
		mSceneMgr = manager;
		actiu = act;
		llistaLlums = new LightList();
		/*if (actiu) {
			llistaNodesLlums = buildLightCut(objecte,arbre->getArrel());
			emplenarLlistaLlums(llistaNodesLlums);
		}
		else {
			emplenarLlistaLlums2(arbre->getLlistaLlums().size());
		}*/
    }

	//Metode que es crida quan volem saber les llums que iluminen un objecte
	const LightList * objectQueryLights(const MovableObject * objecte) {
		//if (llistaLlums->size() == 0) {//(llistaNodesLlums.size() == 0) {
			if (actiu) {
				//cout << endl << endl << "<<<<  ~~~~  ####  ####  ~~~~  >>>>" << endl;
				//cout << "<<<<  ~~~~  ####  ####  ~~~~  >>>>" << endl << "*" << endl << "*" << endl;
				if (llistaNodesLlums.size()==0) {
					llistaNodesLlums = buildLightCut(objecte,arbre->getArrel());
					//cout << "nom: " << objecte->getName() << " llums al cut: " << llistaNodesLlums.size() << endl;
				}
//				for (uint c=0;c<llistaNodesLlums.size();c++){
//					cout << "****** LLUM[" << c << "] : " << llistaNodesLlums[c]->llumRepresentant() << endl;
//				}
				emplenarLlistaLlums(llistaNodesLlums);
//				cout << "****************** LLUMS AL CUT: " << llistaLlums->size() << endl;
//				cout << endl << endl << "<<<<  ~~~~  ####  ####  ~~~~  >>>>" << endl;
//				cout << "<<<<  ~~~~  ####  ####  ~~~~  >>>>" << endl << "*" << endl << "*" << endl;
			}
			else {
				//emplenarLlistaLlums(arbre->getLlistaLlums().size());
				emplenarLlistaLlums(arbre->getLlistaLlums().size());
			}
		//}

		return llistaLlums;
	}

	

protected:
	GeneradorArbre * arbre;
	SceneManager* mSceneMgr;
	std::deque<NodeLlum*> llistaNodesLlums;
	LightList * llistaLlums;
	bool actiu;

	std::deque<NodeLlum*> buildLightCut(const MovableObject * objecte, NodeLlum * node){
	//Calcula el cut de llums per una entitat "objecte" donada una parella de llums "node"
		std::deque<NodeLlum*> cutActual;
		NodeLlum* worst;
		cutActual.push_back(node); //Inicialitzem el cut amb l'arrel de l'arbre
		Real currentTotal = computeTotalIlluminationEstimate(objecte,cutActual);
		node->setErrorBound(calcularCota(objecte,node));
		node->setIlluminationEstimate(illuminationEstimate(objecte,node));
		bool fi = false;
		Real errorBound, illuminationEstimate;

		while (!fi) {
			worst = findWorstErrorBound(objecte,cutActual);
			
			if (worst!=NULL) {
				errorBound = worst->getErrorBound() - worst->getIlluminationEstimate();
				illuminationEstimate = 0.1*currentTotal;

				if (errorBound<0) {errorBound = errorBound * (-1);}
				if ((errorBound==0)|| ((errorBound > illuminationEstimate) && !(sonTotFulles(cutActual)))) {
					cutActual = eliminar(cutActual,worst);
					computeBoundAndEstimateForChildren(worst,objecte);
					//Si algun dels dos fills te errorBound = 0 no el guardem al cut, pero si els seus fills
					/*if (worst->fillDreta()->getErrorBound()==0){}
					else { */cutActual.push_back(worst->fillDreta()); //}
					/*if (worst->fillEsq()->getErrorBound()==0){}
					else { */cutActual.push_back(worst->fillEsq()); //}
					currentTotal = updateTotalIllumination(worst, currentTotal, objecte);
				}
				else {
					
					fi = true;
				}
			}
			else {
				fi = true;
			}
		}

		return cutActual;
	}

	Real calcularCota(const MovableObject * objecte, NodeLlum * node){
	//Donat un objecte determinat i un node de llums, calculem la seva cota maxima
		//Material
		ColourValue colorDifus = ((Entity*)objecte)->getSubEntity(0)->getMaterial()->getBestTechnique(0)->getPass(0)->getDiffuse();
		ColourValue colorEspecular = ((Entity*)objecte)->getSubEntity(0)->getMaterial()->getBestTechnique(0)->getPass(0)->getSpecular();
		Real kDifus = (((Real)1/(Real)3)*colorDifus.r) + (((Real)1/(Real)3)*colorDifus.g) + (((Real)1/(Real)3)*colorDifus.b);
		Real kEspecular = (((Real)1/(Real)3)*colorEspecular.r) + (((Real)1/(Real)3)*colorEspecular.g) + (((Real)1/(Real)3)*colorEspecular.b);
		Real material = kDifus + kEspecular;

		//Geometria
		Vector3 posicioObjecte = ((Entity*)objecte)->getParentSceneNode()->getPosition();
		Vector3 posicioLlum = arbre->getLlum(node->llumRepresentant()).getPosition();
		Real distancia = posicioLlum.distance(posicioObjecte);
		Real geometria = 1 / distancia;

		Vector3 vectorDiferencia = posicioLlum - posicioObjecte;
		Vector3 normalObjecte = Vector3::UNIT_Y;
		Radian angle = vectorDiferencia.normalisedCopy().angleBetween(normalObjecte.normalisedCopy());
		Real valorCosinus = Math::Cos(angle,false);

		Real resultat = 0;

		if (valorCosinus >=0) {
			//Intensitat = intensitat_fillEsq + intensitat_fillDreta
			Real intensitat = 0;
			if (node->esNodePuntual()) {
				intensitat = node->getIntensitat();
			}
			else if (node->esNodeGrup()){
				intensitat = node->fillDreta()->getIntensitat() + node->fillEsq()->getIntensitat();
			}
			else {
				//NO HAURIA D'ENTRAR MAI PER AQUI!!!!
				//cout << "[calcularCota] ATENCIO, HI HA UN NODE AMB UN SOL FILL!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" << endl;
			}

			//Formula: ((K_difus+K_especular)/(distancia*distancia)) * (intensitat)
			resultat =  material * geometria * intensitat;
		}
		else {
//			cout << "****************** 3. Node negatiu. Rep " << node->llumRepresentant() << " posicio: " << posicioLlum << endl;
		}

		//cout << "****************** VALORCOTA node " << node->llumRepresentant() << ": " << resultat << endl;
		
		return resultat;
	}

	Real illuminationEstimate(const MovableObject * objecte, NodeLlum * node){
	//Donat un objecte determinat i un cut de llums, calculem la seva equacio de radiancia
	//Material x Geometria x Visibilitat x Intensitat
		//GEOMETRIA - ACABAT
		Real resultat = 0;
		Vector3 posicioObjecte = ((Entity*)objecte)->getParentSceneNode()->getPosition();
		Vector3 posicioLlum = arbre->getLlum(node->llumRepresentant()).getPosition();
		Real distancia = posicioLlum.distance(posicioObjecte);
		Real geometria = 1 / distancia;

		//MATERIAL: kDifus*cos(angle) + kEspecular*(cos(angle mig)^N)
		
		Vector3 normalObjecte = Vector3::UNIT_Y;
		ColourValue colorDifus = ((Entity*)objecte)->getSubEntity(0)->getMaterial()->getBestTechnique(0)->getPass(0)->getDiffuse();
		ColourValue colorEspecular = ((Entity*)objecte)->getSubEntity(0)->getMaterial()->getBestTechnique(0)->getPass(0)->getSpecular();
		Real kDifus = (((Real)1/(Real)3)*colorDifus.r) + (((Real)1/(Real)3)*colorDifus.g) + (((Real)1/(Real)3)*colorDifus.b);
		Real kEspecular = (((Real)1/(Real)3)*colorEspecular.r) + (((Real)1/(Real)3)*colorEspecular.g) + (((Real)1/(Real)3)*colorEspecular.b);

		//Calculem: kDifus*cos(angle)
		Vector3 vectorDiferencia = posicioLlum - posicioObjecte;
		Radian angle = vectorDiferencia.normalisedCopy().angleBetween(normalObjecte.normalisedCopy());
		Real component1 = Math::Cos(angle,false) * kDifus;
		if (component1>=0) { 
			//kEspecular*(cos(R*V)^N)
			Real rugositat = ((Entity*)objecte)->getSubEntity(0)->getMaterial()->getBestTechnique(0)->getPass(0)->getShininess();
			Vector3 vectorR = vectorDiferencia.normalisedCopy().reflect(normalObjecte.normalisedCopy());
			Vector3 posicioCamara = mSceneMgr->getCamera("PlayerCam")->getPosition();
			Vector3 vectorV = (posicioCamara - posicioObjecte).normalisedCopy();
			Real resultatRV = vectorR.absDotProduct(vectorV);
			Real component2 = Math::Pow(resultatRV,rugositat);
			if (component2<0) { 
				component2= component2 * (-1);
//				cout << "****************** 2. Node negatiu. Rep " << node->llumRepresentant() << " posicio: " << posicioLlum << endl;
			}

			Real material = component1 + component2;

			Vector3 * vectorL = new Vector3(posicioLlum.x,posicioLlum.y,posicioLlum.z);
			
			//VISIBILITAT = 1
			//INTENSITAT
			Real intensitat = 0;
			if (node->esNodePuntual()) {
				intensitat = node->getIntensitat();
			}
			else if (node->esNodeGrup()){
				intensitat = node->fillDreta()->getIntensitat() + node->fillEsq()->getIntensitat();
			}
			else {
				//NO HAURIA D'ENTRAR MAI PER AQUI!!!!
//				cout << "[illuminationEstimate] ATENCIO, HI HA UN NODE AMB UN SOL FILL!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" << endl;
			}

			resultat = geometria * material * 1 * intensitat;
		}
		else {
//			cout << "****************** 1. Node negatiu. Rep " << node->llumRepresentant() << " posicio: " << posicioLlum << endl;
		}

		//cout << "****************** ILLUMINATIONESTIMATE node " << node->llumRepresentant() << ": " << resultat << endl;
		
		return resultat;
	}

	Real computeTotalIlluminationEstimate(const MovableObject * objecte, std::deque<NodeLlum*> cutActual){
	//Calculem l'equacio de radiancia per tot el cut; aixo es la suma de les equacions dels nodes del cut
		Real aux = 0;

		for (uint i=0;i<cutActual.size();i++){
			aux += illuminationEstimate(objecte,cutActual[i]);
		}
		return aux;
	}

	NodeLlum* findWorstErrorBound(const MovableObject * objecte, std::deque<NodeLlum*> cutActual){
	//Ordenem el cut actual amb els nodes amb error bound mes gran davant
		//S'HA DE TENIR EN COMPTE QUE UN NODE SENSE FILLS NO POT SER EL PITJOR DELS NODES!!!!!!!!!!!!!
		std::deque<NodeLlum*> cutAux;
		for (uint a=0;a<cutActual.size();a++) {
			if (cutActual[a]->esNodeGrup()) {
				cutAux.push_back(cutActual[a]);
			}
		}

		for (uint i=1; i<cutAux.size();i++) {
			for(uint j=0;j<cutAux.size() - 1;j++){
				if (cutAux[j]->getErrorBound() < cutAux[j+1]->getErrorBound()) {
					NodeLlum * temp = cutAux[j]; 
					cutAux[j] = cutAux[j+1];
					cutAux[j+1] = temp;
				}
			}
		}
		if (cutAux.size()>0) {
			return cutAux[0];
		}
		else {
			return NULL;
		}
	}

	void computeBoundAndEstimateForChildren(NodeLlum* node, const MovableObject * objecte) {
		if (node->esNodeGrup()) {
			node->fillDreta()->setErrorBound(calcularCota(objecte,node->fillDreta()));
			node->fillDreta()->setIlluminationEstimate(illuminationEstimate(objecte,node->fillDreta()));
			node->fillEsq()->setErrorBound(calcularCota(objecte,node->fillEsq()));
			node->fillEsq()->setIlluminationEstimate(illuminationEstimate(objecte,node->fillEsq()));
		}
	}

	Real updateTotalIllumination(NodeLlum* node, Real currentTotal, const MovableObject * objecte) {
		Real resultat = currentTotal;
		resultat -= node->getIlluminationEstimate();
		
		if (node->esNodePuntual()) {}
		else if (node->esNodeGrup()){
			resultat += node->fillDreta()->getIlluminationEstimate();
			resultat += node->fillEsq()->getIlluminationEstimate();
		}
		else {
			//NO HAURIA D'ENTRAR MAI PER AQUI!!!!
//			cout << "[updateTotalIllumination] ATENCIO, HI HA UN NODE AMB UN SOL FILL!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" << endl;
		}
		
		//currentTotal - (node->getIlluminationEstimate()) + (node->fillDreta()->getIlluminationEstimate()) + (node->fillEsq()->getIlluminationEstimate());
		return resultat;
	}

	bool sonTotFulles(std::deque<NodeLlum*> lightCut) {
	//Recorre tot el lightcut per comprovar si totes les parelles son filles
		bool fulles = true;
		int i = 0;
		while (fulles && i<lightCut.size()) {
			if (lightCut[i]->esNodePuntual()){
				fulles = true;
			}
			else {
				fulles = false;
			}
			i++;
		}

		return fulles;
	}

	void emplenarLlistaLlums(std::deque<NodeLlum*> lightcut){
		llistaLlums = new LightList();
		if (lightcut.size()>0) {
			for (uint i=0;i<lightcut.size();i++) {
				int representant = lightcut[i]->llumRepresentant();
				string nomLlum = "Light";
				char *myBuff = new char[100];
				memset(myBuff,'\0',100);
				itoa(representant,myBuff,10);
				string numLlum = myBuff;
				delete[] myBuff;
				nomLlum.append(numLlum);
				Light * llum = mSceneMgr->getLight(nomLlum);
				//Canviem la intensitat de la llum en funcio de la intensitat actual
				llum->setDiffuseColour(lightcut[i]->getIntensitat(),lightcut[i]->getIntensitat(),lightcut[i]->getIntensitat());
				llum->setSpecularColour(lightcut[i]->getIntensitat(),lightcut[i]->getIntensitat(),lightcut[i]->getIntensitat());
				llistaLlums->push_back(llum);
			}
		}
	}

	void emplenarLlistaLlums(int nLlums){
		llistaLlums = new LightList();
		for (uint i=0;i<nLlums;i++) {
			string nomLlum = "Light";
			char *myBuff = new char[100];
			memset(myBuff,'\0',100);
			itoa(i,myBuff,10);
			string numLlum = myBuff;
			delete[] myBuff;
			nomLlum.append(numLlum);
			Light * llum = mSceneMgr->getLight(nomLlum);
			llistaLlums->push_back(llum);
		}
	}

	void emplenarLlistaLlums2(int nLlums){
		llistaLlums = new LightList();
		for (uint i=nLlums-1;i<0;i--) {
			string nomLlum = "Light";
			char *myBuff = new char[100];
			memset(myBuff,'\0',100);
			itoa(i,myBuff,10);
			string numLlum = myBuff;
			delete[] myBuff;
			nomLlum.append(numLlum);
			Light * llum = mSceneMgr->getLight(nomLlum);
			llistaLlums->push_back(llum);
		}
	}

	std::deque<NodeLlum*> eliminar(std::deque<NodeLlum*> cutActual, NodeLlum* parellaEliminar) {
	//Retorna "cutActual" sense "parellaEliminar"
		std::deque<NodeLlum*> cutAux;
		for (uint i=0;i<cutActual.size();i++){
			if (cutActual[i]->llumRepresentant() != parellaEliminar->llumRepresentant()) {
				cutAux.push_back(cutActual[i]);
			}
		}

		return cutAux;
	}
};

#endif
