#ifndef __NodeGrup_H__
#define __NodeGrup_H__

#include "Ogre.h"
#include "OgreLogManager.h"
#include <iostream>
#include "NodeLlum.h"

using namespace std;

class NodeGrup : public NodeLlum
{

protected:
	NodeLlum * lightEsq;
	NodeLlum * lightDreta;
	Real distancia;

public:
    /// Standard constructor
    NodeGrup()
    {
    }

	NodeGrup(NodeLlum * esq, NodeLlum * dreta, int rep, Real dist, ColourValue dif, ColourValue spec, Real intens){
		lightEsq = esq;
		lightDreta = dreta;
		distancia = dist;
		representant = rep;
		colorDifus = dif;
		colorEspecular = spec;
		intensitat = intens;
	}

	NodeLlum * fillEsq(){
		return lightEsq;
	}

	NodeLlum * fillDreta(){
		return lightDreta;
	}

	Real getDistancia(){
		return distancia;
	}

	int llumNoRepresentant(){
	//Si el representant es l'esquerra, retornem el dret i viceversa
		
		if (representant == lightEsq->llumRepresentant()) {
			return lightDreta->llumRepresentant(); }
		else { 
			return lightEsq->llumRepresentant(); }
	}

	void recalcularIntensitat(){
		intensitat = fillEsq()->getIntensitat() + fillDreta()->getIntensitat();
	}



	void setLightEsq(NodeLlum * esq) {
		lightEsq = esq;
	}

	void setLightDreta(NodeLlum * dreta) {
		lightDreta = dreta;
	}

	void computeBoundingBox(){
		int xMinActual = INT_MAX, xMaxActual = -INT_MAX, yMinActual = INT_MAX, yMaxActual = -INT_MAX, zMinActual = INT_MAX, zMaxActual = -INT_MAX;

		if (fillEsq()->getBB()->getMinX() < xMinActual) xMinActual = fillEsq()->getBB()->getMinX();
		if (fillEsq()->getBB()->getMaxX() > xMaxActual) xMaxActual = fillEsq()->getBB()->getMaxX();
		if (fillEsq()->getBB()->getMinY() < yMinActual) yMinActual = fillEsq()->getBB()->getMinY();
		if (fillEsq()->getBB()->getMaxY() > yMaxActual) yMaxActual = fillEsq()->getBB()->getMaxY();
		if (fillEsq()->getBB()->getMinZ() < zMinActual) zMinActual = fillEsq()->getBB()->getMinZ();
		if (fillEsq()->getBB()->getMaxZ() > zMaxActual) zMaxActual = fillEsq()->getBB()->getMaxZ();
		if (fillDreta()->getBB()->getMinX() < xMinActual) xMinActual = fillDreta()->getBB()->getMinX();
		if (fillDreta()->getBB()->getMaxX() > xMaxActual) xMaxActual = fillDreta()->getBB()->getMaxX();
		if (fillDreta()->getBB()->getMinY() < yMinActual) yMinActual = fillDreta()->getBB()->getMinY();
		if (fillDreta()->getBB()->getMaxY() > yMaxActual) yMaxActual = fillDreta()->getBB()->getMaxY();
		if (fillDreta()->getBB()->getMinZ() < zMinActual) zMinActual = fillDreta()->getBB()->getMinZ();
		if (fillDreta()->getBB()->getMaxZ() > zMaxActual) zMaxActual = fillDreta()->getBB()->getMaxZ();

		BB = new BoundingBox(xMinActual, xMaxActual, yMinActual, yMaxActual, zMinActual, zMaxActual);
	}

	bool esNodeGrup(){ return true; }
	bool esNodePuntual() { return false; }
	
};


#endif
