#ifndef __NodeLlum_H__
#define __NodeLlum_H__

#include "Ogre.h"
#include "OgreLogManager.h"
#include <iostream>
#include "BoundingBox.h"

using namespace std;

class NodeLlum
{

protected:
	
	int representant;
	ColourValue colorDifus;
	ColourValue colorEspecular;
	Real errorBound;
	Real illuminationEstimate;
	Real intensitat;
	BoundingBox * BB;

public:
    /// Standard constructor
    //NodeLlum();
	
	virtual int llumNoRepresentant() = 0;
	virtual NodeLlum * fillEsq() = 0;
	virtual NodeLlum * fillDreta() = 0;
	virtual void recalcularIntensitat() = 0;
	virtual void computeBoundingBox() = 0;
	virtual bool esNodeGrup() = 0;
	virtual bool esNodePuntual() = 0;
	virtual void setLightEsq(NodeLlum * esq) = 0;
	virtual void setLightDreta(NodeLlum * dreta) = 0;
	virtual Real getDistancia() = 0;

	int llumRepresentant(){
		return representant;
	}

	ColourValue getColorDifus(){
		return colorDifus;
	}

	ColourValue getColorEspecular(){
		return colorEspecular;
	}

	Real getErrorBound() {
		return errorBound;
    }

	Real getIlluminationEstimate() {
		return illuminationEstimate;
	}

	Real getIntensitat() {
		return intensitat;
	}

	BoundingBox * getBB(){
		return BB;
	}

	void setErrorBound(Real error) {
		errorBound = error;
    }

	void setIlluminationEstimate(Real illumination) {
		illuminationEstimate = illumination;
	}

	void setIntensitat(Real intens) {
		intensitat = intens;
	}
	
	void setBoundingBox(BoundingBox * bb){
		BB = bb;
	}

	
};


#endif
