#include "prova1.h"
#include "ExampleApplication.h"
#include "GeneradorArbre.h"
#include "ListenerLlums.h"
#include "OgreSceneManager.h"

#include <cstdlib>
#include <stdio.h>
#include <fcntl.h>
#include <io.h>
#include <iostream>
#include <string>
#include "NodeLlum.h"
#include "NodePuntual.h"
#include "NodeGrup.h"
#include <OgreIteratorWrappers.h> 

using namespace std;

void showWin32Console()
{
	static const WORD MAX_CONSOLE_LINES = 500;
	int hConHandle;
	long lStdHandle;
	CONSOLE_SCREEN_BUFFER_INFO coninfo;
	FILE *fp;
	// allocate a console for this app
	AllocConsole();
	// set the screen buffer to be big enough to let us scroll text
	GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE), &coninfo);
	coninfo.dwSize.Y = MAX_CONSOLE_LINES;
	SetConsoleScreenBufferSize(GetStdHandle(STD_OUTPUT_HANDLE),
	coninfo.dwSize);
	// redirect unbuffered STDOUT to the console
	lStdHandle = (long)GetStdHandle(STD_OUTPUT_HANDLE);
	hConHandle = _open_osfhandle(lStdHandle, _O_TEXT);
	fp = _fdopen( hConHandle, "w" );
	*stdout = *fp;
	setvbuf( stdout, NULL, _IONBF, 0 );
	// redirect unbuffered STDIN to the console
	lStdHandle = (long)GetStdHandle(STD_INPUT_HANDLE);
	hConHandle = _open_osfhandle(lStdHandle, _O_TEXT);
	fp = _fdopen( hConHandle, "r" );
	*stdin = *fp;
	setvbuf( stdin, NULL, _IONBF, 0 );
	// redirect unbuffered STDERR to the console
	lStdHandle = (long)GetStdHandle(STD_ERROR_HANDLE);
	hConHandle = _open_osfhandle(lStdHandle, _O_TEXT);
	fp = _fdopen( hConHandle, "w" );
	*stderr = *fp;
	setvbuf( stderr, NULL, _IONBF, 0 );
	// make cout, wcout, cin, wcin, wcerr, cerr, wclog and clog
	// point to console as well
	std::ios::sync_with_stdio();
}

class TutorialApplication : public ExampleApplication
{
protected:
public:
    TutorialApplication()
    {
    }

    ~TutorialApplication() 
    {
    }
protected:
    virtual void createCamera(void)
    {
        mCamera = mSceneMgr->createCamera("PlayerCam");
        mCamera->setPosition(Vector3(0,350,350));
        mCamera->lookAt(Vector3(0,0,0));
        mCamera->setNearClipDistance(5);
    }

    virtual void createViewports(void)
    {
        Viewport* vp = mWindow->addViewport(mCamera);
        vp->setBackgroundColour(ColourValue(0,0,0));
        mCamera->setAspectRatio(Real(vp->getActualWidth()) / Real(vp->getActualHeight()));   
    }

    void createScene(void)
    {
		//afegirLlum();
		//escenaSenzilla();
		escenaComplexa();
		//afegirObjectes();
	}
	
	void escenaSenzilla(){
		ListenerLlums * listener;
		mSceneMgr->setAmbientLight(ColourValue(0, 0, 0));
		mSceneMgr->setShadowTechnique( SHADOWTYPE_STENCIL_MODULATIVE );
		std::deque<Light> llistaLlums = llumsSenzilles();
		std::deque<Entity*> llistaObjectes = objectesSenzills();
		GeneradorArbre * genArbre = new GeneradorArbre(llistaLlums);
		for (uint i=0;i<llistaObjectes.size();i++) {
			listener = new ListenerLlums(genArbre,mSceneMgr,true);
			llistaObjectes[i]->setListener(listener);
		}
	}

	std::deque<Light> llumsSenzilles(){
		std::deque<Light> llistaLlums;
		Light * light;

		light = mSceneMgr->createLight("Light0");
		light->setPosition(-300,5,100);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(1,1,1);
		light->setSpecularColour(1,1,1);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light1");
		light->setPosition(-320,10,110);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(1,1,1);
		light->setSpecularColour(1,1,1);
		light->setVisible(true);
		llistaLlums.push_back(*light);
		
		light = mSceneMgr->createLight("Light2");
		light->setPosition(1000,10,190);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(0.5,0.5,0.5);
		light->setSpecularColour(0.5,0.5,0.5);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light3");
		light->setPosition(1050,50,190);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(0.5,0.5,0.5);
		light->setSpecularColour(0.5,0.5,0.5);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light4");
		light->setPosition(-510,20,210);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(1,1,1);
		light->setSpecularColour(1,1,1);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light5");
		light->setPosition(-520,35,220);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(1,1,1);
		light->setSpecularColour(1,1,1);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light6");
		light->setPosition(50,600,500);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(1,1,1);
		light->setSpecularColour(1,1,1);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light7");
		light->setPosition(70,650,550);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(1,1,1);
		light->setSpecularColour(1,1,1);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light8");
		light->setPosition(80,700,500);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(0.5,0.5,0.5);
		light->setSpecularColour(0.5,0.5,0.5);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light9");
		light->setPosition(90,720,530);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(0.5,0.5,0.5);
		light->setSpecularColour(0.5,0.5,0.5);
		light->setVisible(true);
		llistaLlums.push_back(*light);
		
		return llistaLlums;
	}

	std::deque<Entity*> objectesSenzills() {
		Entity * ent;
		SceneNode * mNode;
		std::deque<Entity*> llistaObjectes;

		Plane plane(Vector3::UNIT_Y, 0);
		MeshManager::getSingleton().createPlane("pla", ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, plane, 50,50,20,20,true,1,5,5,Vector3::UNIT_Z);
        
		//Pla1
		ent = mSceneMgr->createEntity("Pla1", "pla");
		ent->setMaterialName("Proves/Guillem");
        ent->setCastShadows(false);
		//ent->setListener((MovableObject::Listener*)llista);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(-200,0,0);
		mNode->attachObject(ent);
		llistaObjectes.push_back(ent);

		//Pla2
        ent = mSceneMgr->createEntity("Pla2", "pla");
		ent->setMaterialName("Proves/Guillem2");
        ent->setCastShadows(false);
		//ent->setListener((MovableObject::Listener*)llista2);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(-100,0,0);
		mNode->attachObject(ent);
		llistaObjectes.push_back(ent);

		//Pla3
        ent = mSceneMgr->createEntity("Pla3", "pla");
		ent->setMaterialName("Proves/Guillem3");
        ent->setCastShadows(false);
		//ent->setListener((MovableObject::Listener*)llista3);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(0,0,0);
		mNode->attachObject(ent);
		llistaObjectes.push_back(ent);

		//Pla4
        ent = mSceneMgr->createEntity("Pla4", "pla");
		ent->setMaterialName("Proves/Guillem2");
        ent->setCastShadows(false);
		//ent->setListener((MovableObject::Listener*)llista4);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(100,0,0);
		mNode->attachObject(ent);
		llistaObjectes.push_back(ent);

		//Pla5
        ent = mSceneMgr->createEntity("Pla5", "pla");
		ent->setMaterialName("Proves/Guillem");
        ent->setCastShadows(false);
		//ent->setListener((MovableObject::Listener*)llista5);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(200,0,0);
		mNode->attachObject(ent);
		llistaObjectes.push_back(ent);

		//FILA2
		//Pla6
        ent = mSceneMgr->createEntity("Pla6", "pla");
		ent->setMaterialName("Proves/Guillem2");
        ent->setCastShadows(false);
		//ent->setListener((MovableObject::Listener*)llista6);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(-200,0,-300);
		mNode->attachObject(ent);
		llistaObjectes.push_back(ent);

		//Pla7
        ent = mSceneMgr->createEntity("Pla7", "pla");
		ent->setMaterialName("Proves/Guillem3");
        ent->setCastShadows(false);
		//ent->setListener((MovableObject::Listener*)llista7);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(-100,0,-300);
		mNode->attachObject(ent);
		llistaObjectes.push_back(ent);

		//Pla8
        ent = mSceneMgr->createEntity("Pla8", "pla");
		ent->setMaterialName("Proves/Guillem2");
        ent->setCastShadows(false);
		//ent->setListener((MovableObject::Listener*)llista8);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(0,0,-300);
		mNode->attachObject(ent);
		llistaObjectes.push_back(ent);

		//Pla9
        ent = mSceneMgr->createEntity("Pla9", "pla");
		ent->setMaterialName("Proves/Guillem3");
        ent->setCastShadows(false);
		//ent->setListener((MovableObject::Listener*)llista9);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(100,0,-300);
		mNode->attachObject(ent);
		llistaObjectes.push_back(ent);

		//Pla10
        ent = mSceneMgr->createEntity("Pla10", "pla");
		ent->setMaterialName("Proves/Guillem2");
        ent->setCastShadows(false);
		//ent->setListener((MovableObject::Listener*)llista9);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(200,0,-300);
		mNode->attachObject(ent);
		llistaObjectes.push_back(ent);

		return llistaObjectes;
	}

	
	void escenaComplexa(){
		mCamera->setPosition(Vector3(3,23,33));
		ListenerLlums * listener;
		mSceneMgr->setAmbientLight(ColourValue(0, 0, 0));
		mSceneMgr->setShadowTechnique( SHADOWTYPE_STENCIL_MODULATIVE );
		std::deque<Light> llistaLlums = llumsComplexes();
		std::deque<Entity*> llistaObjectes = objectesComplexes();
		GeneradorArbre * genArbre = new GeneradorArbre(llistaLlums);
		for (uint i=0;i<llistaObjectes.size();i++) {
			listener = new ListenerLlums(genArbre,mSceneMgr,true);
			llistaObjectes[i]->setListener(listener);
		}
	}

	std::deque<Light> llumsComplexes(){
		std::deque<Light> llistaLlums;
		Light * light;

		light = mSceneMgr->createLight("Light0");
		light->setPosition(-35,35,10);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(1,1,1);
		light->setSpecularColour(1,1,1);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light1");
		light->setPosition(-32,32,11);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(0.8,0.8,0.8);
		light->setSpecularColour(0.8,0.8,0.8);
		light->setVisible(true);
		llistaLlums.push_back(*light);
		
		light = mSceneMgr->createLight("Light2");
		light->setPosition(32,60,-15);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(0.5,0.5,0.5);
		light->setSpecularColour(0.5,0.5,0.5);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light3");
		light->setPosition(32,64,-15);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(0.5,0.5,0.5);
		light->setSpecularColour(0.5,0.5,0.5);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light4");
		light->setPosition(-25,80,-30);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(1,1,1);
		light->setSpecularColour(1,1,1);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light5");
		light->setPosition(-27,85,-29);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(1,1,1);
		light->setSpecularColour(1,1,1);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light6");
		light->setPosition(5,90,70);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(1,1,1);
		light->setSpecularColour(1,1,1);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light7");
		light->setPosition(7,89,69);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(1,1,1);
		light->setSpecularColour(1,1,1);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light8");
		light->setPosition(-20,29,20);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(0.5,0.5,0.5);
		light->setSpecularColour(0.5,0.5,0.5);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light9");
		light->setPosition(-19,30,23);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(0.5,0.5,0.5);
		light->setSpecularColour(0.5,0.5,0.5);
		light->setVisible(true);
		llistaLlums.push_back(*light);
		
		return llistaLlums;
	}

	std::deque<Entity*> objectesComplexes() {
		Entity * ent;
		SceneNode * mNode;
		std::deque<Entity*> llistaObjectes;


		/*Plane plane(Vector3::UNIT_Y, 0);
		MeshManager::getSingleton().createPlane("pla", ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, plane, 6,6,20,20,true,1,5,5,Vector3::UNIT_Z);
        
		for (uint i=0;i<5;i++){
			for (uint j=0;j<5;j++){
				string nomLlum = "Pla";
				char *myBuff = new char[100];
				memset(myBuff,'\0',100);
				char *myBuff2 = new char[100];
				memset(myBuff2,'\0',100);
				itoa(i-5,myBuff,10);
				itoa(j-5,myBuff2,10);
				string numLlum = myBuff;
				string numLlum2 = myBuff2;
				delete[] myBuff;
				nomLlum.append(numLlum);
				nomLlum.append("_");
				nomLlum.append(numLlum2);
				cout << "nomLlum: "<< nomLlum << endl;
				ent = mSceneMgr->createEntity(nomLlum, "pla");
				ent->setMaterialName("Proves/Guillem2");
				ent->setCastShadows(false);
				mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
				mNode->setPosition(i+6,0,j+6);
				mNode->attachObject(ent);
				llistaObjectes.push_back(ent);
			}
		}*/
		//Pla1
		Plane plane(Vector3::UNIT_Y, 0);
		MeshManager::getSingleton().createPlane("pla", ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, plane, 70,70,20,20,true,1,5,5,Vector3::UNIT_Z);
		ent = mSceneMgr->createEntity("Pla1", "pla");
		ent->setMaterialName("Examples/Rockwall");
        ent->setCastShadows(false);
		mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(0,0,0);
		mNode->attachObject(ent);
		llistaObjectes.push_back(ent);
		
		//Barril
		ent = mSceneMgr->createEntity("Barril", "Barrel.mesh");
        ent->setCastShadows(false);
		mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(-10,3,0);
		mNode->attachObject(ent);
		llistaObjectes.push_back(ent);

		//Palet1
		ent = mSceneMgr->createEntity("Palet1", "WoodPallet.mesh");
        ent->setCastShadows(false);
		mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(5,1,3);
		mNode->attachObject(ent);
		mNode->yaw(Degree(31));
		llistaObjectes.push_back(ent);

		//Palet2
		ent = mSceneMgr->createEntity("Palet2", "WoodPallet.mesh");
        ent->setCastShadows(false);
		mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(-5,5,0);
		mNode->attachObject(ent);
		mNode->roll(Degree(-45));
		mNode->yaw(Degree(5));
		llistaObjectes.push_back(ent);

		//Avio
		ent = mSceneMgr->createEntity("Avio", "RZR-002.mesh");
        ent->setCastShadows(false);
		mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(13,0,15);
		mNode->attachObject(ent);
		mNode->scale(.5,.5,.5);
		mNode->yaw(Degree(-35));
		llistaObjectes.push_back(ent);


		return llistaObjectes;
	}

	
	
	void afegirLlum()
	{
		
		Light *light;

		mSceneMgr->setAmbientLight(ColourValue(0, 0, 0));
		mSceneMgr->setShadowTechnique( SHADOWTYPE_STENCIL_MODULATIVE );
		std::deque<Light> llistaLlums;
	
		for (uint c=0;c<5;c++) {
			//generem el nom
			string nomLlum = "Light";
			char *myBuff = new char[100];
			memset(myBuff,'\0',100);
			itoa(c,myBuff,10);
			string numLlum = myBuff;
			delete[] myBuff;
			nomLlum.append(numLlum);
			light = mSceneMgr->createLight(nomLlum);
			Real aleatoriX = (Real)Real(rand())/(Real)(RAND_MAX);
			Real aleatoriX100 = aleatoriX*100;
			Real aleatoriY = (Real)Real(rand())/(Real)(RAND_MAX);
			Real aleatoriY100 = aleatoriY*100;
			Real aleatoriZ = (Real)Real(rand())/(Real)(RAND_MAX);
			Real aleatoriZ100 = aleatoriZ*100;
			light->setPosition(aleatoriX100,aleatoriY100,aleatoriZ100);
			light->setType(Light::LT_POINT);
			light->setDiffuseColour(aleatoriX,aleatoriX,aleatoriX);
			light->setSpecularColour(aleatoriX,aleatoriX,aleatoriX);
			light->setVisible(true);
			llistaLlums.push_back(*light);
			
			c = c+1;
			//Segona llum
			nomLlum = "Light";
			myBuff = new char[100];
			memset(myBuff,'\0',100);
			itoa(c,myBuff,10);
			numLlum = myBuff;
			delete[] myBuff;
			nomLlum.append(numLlum);
			light = mSceneMgr->createLight(nomLlum);
			light->setPosition(aleatoriX100+10,aleatoriY100+10,aleatoriZ100+10);
			light->setType(Light::LT_POINT);
			light->setDiffuseColour(aleatoriX,aleatoriX,aleatoriX);
			light->setSpecularColour(aleatoriX,aleatoriX,aleatoriX);
			light->setVisible(true);
			llistaLlums.push_back(*light);
		}
		
		/*light = mSceneMgr->createLight("Light0");
		light->setPosition(-300,5,100);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(1,1,1);
		light->setSpecularColour(1,1,1);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light1");
		light->setPosition(-320,10,110);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(1,1,1);
		light->setSpecularColour(1,1,1);
		light->setVisible(true);
		llistaLlums.push_back(*light);
		
		light = mSceneMgr->createLight("Light2");
		light->setPosition(1000,10,190);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(0.5,0.5,0.5);
		light->setSpecularColour(0.5,0.5,0.5);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light3");
		light->setPosition(1050,50,190);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(0.5,0.5,0.5);
		light->setSpecularColour(0.5,0.5,0.5);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light4");
		light->setPosition(-510,20,210);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(1,1,1);
		light->setSpecularColour(1,1,1);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light5");
		light->setPosition(-520,35,220);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(1,1,1);
		light->setSpecularColour(1,1,1);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light6");
		light->setPosition(50,600,500);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(1,1,1);
		light->setSpecularColour(1,1,1);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light7");
		light->setPosition(70,650,550);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(1,1,1);
		light->setSpecularColour(1,1,1);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light8");
		light->setPosition(80,700,500);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(0.5,0.5,0.5);
		light->setSpecularColour(0.5,0.5,0.5);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light9");
		light->setPosition(90,720,530);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(0.5,0.5,0.5);
		light->setSpecularColour(0.5,0.5,0.5);
		light->setVisible(true);
		llistaLlums.push_back(*light);/*

		light = mSceneMgr->createLight("Light10");
		light->setPosition(-250,250,-250);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(0.4,0.4,0.4);
		light->setSpecularColour(0.4,0.4,0.4);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light11");
		light->setPosition(250,-250,-250);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(0.4,0.4,0.4);
		light->setSpecularColour(0.4,0.4,0.4);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light12");
		light->setPosition(-710,50,150);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(0.7,0.7,0.7);
		light->setSpecularColour(0.7,0.7,0.7);
		light->setVisible(true);
		llistaLlums.push_back(*light);

		light = mSceneMgr->createLight("Light13");
		light->setPosition(-730,60,120);
		light->setType(Light::LT_POINT);
		light->setDiffuseColour(0.8,0.8,0.8);
		light->setSpecularColour(0.8,0.8,0.8);
		light->setVisible(true);
		llistaLlums.push_back(*light);*/

		Entity *ent;
		SceneNode *mNode;

	//	cout << "****************** Nombre de llums:      \t" << llistaLlums.size() << "" << endl;

		GeneradorArbre * genArbre = new GeneradorArbre(llistaLlums);
		/*ListenerLlums * llista = new ListenerLlums(genArbre,mSceneMgr,false);
		ListenerLlums * llista2 = new ListenerLlums(genArbre,mSceneMgr,false);
		ListenerLlums * llista3 = new ListenerLlums(genArbre,mSceneMgr,false);
		ListenerLlums * llista4 = new ListenerLlums(genArbre,mSceneMgr,false);
		ListenerLlums * llista5 = new ListenerLlums(genArbre,mSceneMgr,false);
		ListenerLlums * llista6 = new ListenerLlums(genArbre,mSceneMgr,false);
		ListenerLlums * llista7 = new ListenerLlums(genArbre,mSceneMgr,false);
		ListenerLlums * llista8 = new ListenerLlums(genArbre,mSceneMgr,false);
		ListenerLlums * llista9 = new ListenerLlums(genArbre,mSceneMgr,false);
		ListenerLlums * llista10 = new ListenerLlums(genArbre,mSceneMgr,false);*/

		//FILA1
		//Pla1
		/*ent = mSceneMgr->createEntity("OgreHead", "cube.mesh");
		ent->setCastShadows(false);
		ent->setMaterialName("Proves/Guillem3");
		mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(10,85,50);
		mNode->attachObject(ent);*/
		//mNode->translate(Vector3(-500,0,0));
		ent = mSceneMgr->createEntity("OgreHead", "RZR-002.mesh");
		ent->setCastShadows(false);
		mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->attachObject(ent);
		std::deque<Entity*> llistaEntitats = separaTriangles(ent->getMesh(),genArbre);
		//cout << "tamany llista entitats: " << llistaEntitats.size() << "________---------_______" << endl;
		/*
		if (mSceneMgr->getEntity("Entitat1") != NULL) {
			cout << "diferent de null" << endl;
		}
		else {
			cout << "igual a null" << endl;
		}
		cout << "tamany llista entitats: " << llistaEntitats.size() << "________---------_______" << endl;*/

		/*Plane plane(Vector3::UNIT_Y, 0);
		MeshManager::getSingleton().createPlane("pla", ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, plane, 50,50,20,20,true,1,5,5,Vector3::UNIT_Z);
		for (uint p=0;p<40;p++){
			string nomEnt = "Pla";
			char *myBuff = new char[100];
			memset(myBuff,'\0',100);
			itoa(p,myBuff,10);
			string numEnt = myBuff;
			delete[] myBuff;
			nomEnt.append(numEnt);
			ent = mSceneMgr->createEntity(nomEnt, "pla");
			ent->setMaterialName("Proves/Guillem2");
			ent->setCastShadows(false);
			ListenerLlums * llista = new ListenerLlums(genArbre,mSceneMgr,true);
			ent->setListener((MovableObject::Listener*)llista);
			mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
			Real aleatoriX = (Real)Real(rand())/(Real)(RAND_MAX);
			Real aleatoriX100 = aleatoriX*100;
			Real aleatoriY = (Real)Real(rand())/(Real)(RAND_MAX);
			Real aleatoriY100 = aleatoriY*100;
			Real aleatoriZ = (Real)Real(rand())/(Real)(RAND_MAX);
			Real aleatoriZ100 = aleatoriZ*100;
			mNode->setPosition(aleatoriX100,aleatoriY100,aleatoriZ100);
			mNode->attachObject(ent);

		}*/
		/*
		Plane plane(Vector3::UNIT_Y, 0);
		MeshManager::getSingleton().createPlane("pla", ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, plane, 50,50,20,20,true,1,5,5,Vector3::UNIT_Z);
        ent = mSceneMgr->createEntity("Pla1", "pla");
		ent->setMaterialName("Proves/Guillem");
        ent->setCastShadows(false);
		ent->setListener((MovableObject::Listener*)llista);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(-200,0,0);
		
		
		

		//Pla2
        ent = mSceneMgr->createEntity("Pla2", "pla");
		ent->setMaterialName("Proves/Guillem2");
        ent->setCastShadows(false);
		ent->setListener((MovableObject::Listener*)llista2);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(-100,0,0);
		mNode->attachObject(ent);

		//Pla3
        ent = mSceneMgr->createEntity("Pla3", "pla");
		ent->setMaterialName("Proves/Guillem3");
        ent->setCastShadows(false);
		ent->setListener((MovableObject::Listener*)llista3);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(0,0,0);
		mNode->attachObject(ent);

		//Pla4
        ent = mSceneMgr->createEntity("Pla4", "pla");
		ent->setMaterialName("Proves/Guillem2");
        ent->setCastShadows(false);
		ent->setListener((MovableObject::Listener*)llista4);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(100,0,0);
		mNode->attachObject(ent);

		//Pla5
        ent = mSceneMgr->createEntity("Pla5", "pla");
		ent->setMaterialName("Proves/Guillem");
        ent->setCastShadows(false);
		ent->setListener((MovableObject::Listener*)llista5);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(200,0,0);
		mNode->attachObject(ent);

		//FILA2
		//Pla6
        ent = mSceneMgr->createEntity("Pla6", "pla");
		ent->setMaterialName("Proves/Guillem2");
        ent->setCastShadows(false);
		ent->setListener((MovableObject::Listener*)llista6);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(-200,0,-300);
		mNode->attachObject(ent);

		//Pla7
        ent = mSceneMgr->createEntity("Pla7", "pla");
		ent->setMaterialName("Proves/Guillem3");
        ent->setCastShadows(false);
		ent->setListener((MovableObject::Listener*)llista7);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(-100,0,-300);
		mNode->attachObject(ent);

		//Pla8
        ent = mSceneMgr->createEntity("Pla8", "pla");
		ent->setMaterialName("Proves/Guillem2");
        ent->setCastShadows(false);
		ent->setListener((MovableObject::Listener*)llista8);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(0,0,-300);
		mNode->attachObject(ent);

		//Pla9
        ent = mSceneMgr->createEntity("Pla9", "pla");
		ent->setMaterialName("Proves/Guillem");
        ent->setCastShadows(false);
		ent->setListener((MovableObject::Listener*)llista9);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(100,0,-300);
		mNode->attachObject(ent);

		//Pla10
        ent = mSceneMgr->createEntity("Pla10", "pla");
		ent->setMaterialName("Proves/Guillem2");
        ent->setCastShadows(false);
		ent->setListener((MovableObject::Listener*)llista10);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(200,0,-300);
		mNode->attachObject(ent);*/
		
	}

	void afegirObjectes2()
	{	

	}

	std::deque<Entity*> separaTriangles(MeshPtr clonMesh, GeneradorArbre * arbre){
		std::deque<Entity*> llistat;

	/// Create the mesh via the MeshManager
	Ogre::MeshPtr msh = MeshManager::getSingleton().createManual("meshProves", "General");
	
	size_t vertex_count = 0;
	for(int m=0; m < clonMesh->getNumSubMeshes(); m++) { // Para todas las subMeshes

			SubMesh* subMeshN = clonMesh->getSubMesh(m);
	

	Ogre::VertexData* vertex_data = subMeshN->vertexData;
    vertex_count += vertex_data->vertexCount;	

	int ind =0;		
	
	Ogre::VertexData* vertexData = subMeshN->vertexData;


	IndexData* facedata = subMeshN->indexData;

			if (facedata->indexCount > 0)
			{
				// Write each face in turn
				bool use32BitIndexes = (facedata->indexBuffer->getType() == HardwareIndexBuffer::IT_32BIT);
				// Write each face in turn
				unsigned int* pInt;
				unsigned int iVertexA, iVertexB, iVertexC;
				unsigned short* pShort;
				unsigned short sVertexA, sVertexB, sVertexC;
				HardwareIndexBufferSharedPtr ibuf = facedata->indexBuffer;

				bool pos = false; bool nor = false; bool bin = false; bool tan = false; bool spe = false; bool dif = false;
				bool tc = false;

				
				Ogre::VertexDeclaration::VertexElementList::iterator	it, iend;
				Ogre::VertexDeclaration::VertexElementList elemList;


			
            
        

			Ogre::VertexData* vertexData = subMeshN->vertexData;

			int nGroups = 0;
			int textC = 0;
			int nVertices = 3;
			unsigned short currentBuffer = 999;

			elemList = subMeshN->vertexData->vertexDeclaration->getElements();
			iend = elemList.end();
				

					
				for (it = elemList.begin(); it != iend; ++it)
				{
					if (it->getSource() != currentBuffer)
					{
						currentBuffer = it->getSource();
					}

					if (it->getSemantic() == VES_TEXTURE_COORDINATES)
					{
						tc = true;
						textC = 1;}
					if (it->getSemantic() == VES_POSITION)
					{
						pos = true;
						nGroups++;}
					if (it->getSemantic() == VES_NORMAL)
					{
						nor = true;
						nGroups++;}
					if (it->getSemantic() == VES_BINORMAL)
					{
						bin = true;
						nGroups++;}
					if (it->getSemantic() == VES_TANGENT)
					{
						tan = true;
						nGroups++;}
					if (it->getSemantic() == VES_SPECULAR)
					{
						spe = true;}
					if (it->getSemantic() == VES_DIFFUSE)
					{
						dif = true;}

				}

				int vbufCount = (3*nGroups*nVertices)+(textC*2*nVertices);
				




				if (use32BitIndexes){

					pInt = static_cast<unsigned int*>(
						ibuf->lock(HardwareBuffer::HBL_READ_ONLY)); 
				}else{

					pShort = static_cast<unsigned short*>(
						ibuf->lock(HardwareBuffer::HBL_READ_ONLY)); 
				}
				
				size_t numTri = facedata->indexCount / 3;
					
				for (size_t f = 0; f < facedata->indexCount; f += 3){
					ind++;
						/// Create the mesh via the MeshManager
						Ogre::MeshPtr msh = MeshManager::getSingleton().createManual("meshProves", "General");
	
						//creem una subMesh
						SubMesh* sub = msh->createSubMesh("prova");
						int nVertices = 3;
						int j = 0;
		

					if (use32BitIndexes)
					{
						
						iVertexA = *pInt++; iVertexB = *pInt++; iVertexC = *pInt++;
						float *vertices = new float[vbufCount*sizeof(float)];
			///////////////////Recollir posicio vertex A
						

						const Ogre::VertexElement* positionElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_POSITION);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(positionElem->getSource());
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pPos;

						vertex = vertex + (vbuf->getVertexSize() * (iVertexA));
				
						positionElem->baseVertexPointerToElement(vertex, &pPos);
						vertices[j] = pPos[0];
						j++;
						vertices[j] = pPos[1];
						j++;
						vertices[j] = pPos[2];
						j++;

/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}			*/
			////////////////Recollir normal A

					if(nor){						
						const Ogre::VertexElement* normalElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_NORMAL);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(normalElem->getSource());
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pNor;

						vertex = vertex + (vbuf->getVertexSize() * (iVertexA));
				
						normalElem->baseVertexPointerToElement(vertex, &pNor);
						vertices[j] = pNor[0];
						j++;
						vertices[j] = pNor[1];
						j++;
						vertices[j] = pNor[2];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////Recollir binormal A

					if(bin){						
						const Ogre::VertexElement* binormalElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_BINORMAL);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(binormalElem->getSource());
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pBin;

						vertex = vertex + (vbuf->getVertexSize() * (iVertexA));
				
						binormalElem->baseVertexPointerToElement(vertex, &pBin);
						vertices[j] = pBin[0];
						j++;
						vertices[j] = pBin[1];
						j++;
						vertices[j] = pBin[2];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////Recollir tangent A

					if(tan){						
						const Ogre::VertexElement* tangentElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_TANGENT);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(tangentElem->getSource());
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pTan;

						vertex = vertex + (vbuf->getVertexSize() * (iVertexA));
				
						tangentElem->baseVertexPointerToElement(vertex, &pTan);
						vertices[j] = pTan[0];
						j++;
						vertices[j] = pTan[1];
						j++;
						vertices[j] = pTan[2];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////Recollir textCoord A

					if(tc){						
						const Ogre::VertexElement* tcElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_TEXTURE_COORDINATES);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(tcElem->getSource());
						//if (vbuf->isLocked()){vbuf->unlock();}
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pTc;

						vertex = vertex + (vbuf->getVertexSize() * (iVertexA));
				
						tcElem->baseVertexPointerToElement(vertex, &pTc);
						vertices[j] = pTc[0];
						j++;
						vertices[j] = pTc[1];
						j++;
					}
			////////////////////////////////////////////////////


			///////////////////Recollir posicio vertex B

						positionElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_POSITION);
						vbuf = vertexData->vertexBufferBinding->getBuffer(positionElem->getSource());
						vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));

						vertex = vertex + (vbuf->getVertexSize() * (iVertexB));
				
						positionElem->baseVertexPointerToElement(vertex, &pPos);
						vertices[j] = pPos[0];
						j++;
						vertices[j] = pPos[1];
						j++;
						vertices[j] = pPos[2];
						j++;
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}		*/	
			////////////////Recollir normal B

					if(nor){						
						const Ogre::VertexElement* normalElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_NORMAL);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(normalElem->getSource());
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pNor;
						vertex = vertex + (vbuf->getVertexSize() * (iVertexB));
				
						normalElem->baseVertexPointerToElement(vertex, &pNor);
						vertices[j] = pNor[0];
						j++;
						vertices[j] = pNor[1];
						j++;
						vertices[j] = pNor[2];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////Recollir binormal B

					if(bin){						
						const Ogre::VertexElement* binormalElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_BINORMAL);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(binormalElem->getSource());
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pBin;
						vertex = vertex + (vbuf->getVertexSize() * (iVertexB));
				
						binormalElem->baseVertexPointerToElement(vertex, &pBin);
						vertices[j] = pBin[0];
						j++;
						vertices[j] = pBin[1];
						j++;
						vertices[j] = pBin[2];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////Recollir tangent B

					if(tan){						
						const Ogre::VertexElement* tangentElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_TANGENT);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(tangentElem->getSource());
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pTan;
						vertex = vertex + (vbuf->getVertexSize() * (iVertexB));
				
						tangentElem->baseVertexPointerToElement(vertex, &pTan);
						vertices[j] = pTan[0];
						j++;
						vertices[j] = pTan[1];
						j++;
						vertices[j] = pTan[2];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////Recollir textCoord B

					if(tc){						
						const Ogre::VertexElement* tcElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_TEXTURE_COORDINATES);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(tcElem->getSource());
						//if (vbuf->isLocked()){vbuf->unlock();}
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pTc;

						vertex = vertex + (vbuf->getVertexSize() * (iVertexB));
				
						tcElem->baseVertexPointerToElement(vertex, &pTc);
						vertices[j] = pTc[0];
						j++;
						vertices[j] = pTc[1];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////////////////////////////////////////

			///////////////////Recollir posicio vertex C

						positionElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_POSITION);
						vbuf = vertexData->vertexBufferBinding->getBuffer(positionElem->getSource());
						vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						
						vertex = vertex + (vbuf->getVertexSize() * (iVertexC));
				
						positionElem->baseVertexPointerToElement(vertex, &pPos);
						vertices[j] = pPos[0];
						j++;
						vertices[j] = pPos[1];
						j++;
						vertices[j] = pPos[2];
						j++;
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}	*/		
			////////////////Recollir normal C

					if(nor){						
						const Ogre::VertexElement* normalElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_NORMAL);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(normalElem->getSource());
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pNor;

						vertex = vertex + (vbuf->getVertexSize() * (iVertexC));
				
						normalElem->baseVertexPointerToElement(vertex, &pNor);
						vertices[j] = pNor[0];
						j++;
						vertices[j] = pNor[1];
						j++;
						vertices[j] = pNor[2];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////Recollir binormal C

					if(bin){						
						const Ogre::VertexElement* binormalElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_BINORMAL);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(binormalElem->getSource());
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pBin;

						vertex = vertex + (vbuf->getVertexSize() * (iVertexC));
				
						binormalElem->baseVertexPointerToElement(vertex, &pBin);
						vertices[j] = pBin[0];
						j++;
						vertices[j] = pBin[1];
						j++;
						vertices[j] = pBin[2];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////Recollir tangent C

					if(tan){						
						const Ogre::VertexElement* tangentElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_TANGENT);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(tangentElem->getSource());
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pTan;

						vertex = vertex + (vbuf->getVertexSize() * (iVertexC));
				
						tangentElem->baseVertexPointerToElement(vertex, &pTan);
						vertices[j] = pTan[0];
						j++;
						vertices[j] = pTan[1];
						j++;
						vertices[j] = pTan[2];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////Recollir textCoord C

					if(tc){						
						const Ogre::VertexElement* tcElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_TEXTURE_COORDINATES);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(tcElem->getSource());
						//if (vbuf->isLocked()){vbuf->unlock();}
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pTc;

						vertex = vertex + (vbuf->getVertexSize() * (iVertexC));
				
						tcElem->baseVertexPointerToElement(vertex, &pTc);
						vertices[j] = pTc[0];
						j++;
						vertices[j] = pTc[1];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////////////////////////////////////////
					
					VertexDeclaration* decl = sub->vertexData->vertexDeclaration;
					size_t offset = 0;


					if(pos){
						decl->addElement(0, offset, VET_FLOAT3, VES_POSITION);
						offset += VertexElement::getTypeSize(VET_FLOAT3);}
					if(nor){
						decl->addElement(0, offset, VET_FLOAT3, VES_NORMAL);
						offset += VertexElement::getTypeSize(VET_FLOAT3);}
					if(bin){
						decl->addElement(0, offset, VET_FLOAT3, VES_BINORMAL);
						offset += VertexElement::getTypeSize(VET_FLOAT3);}
					if(tan){
						decl->addElement(0, offset, VET_FLOAT3, VES_TANGENT);
						offset += VertexElement::getTypeSize(VET_FLOAT3);}
					if(tc){		
						decl->addElement(0, offset, VET_FLOAT2, VES_TEXTURE_COORDINATES);
						offset += VertexElement::getTypeSize(VET_FLOAT2);}

					vbuf = 
						HardwareBufferManager::getSingleton().createVertexBuffer(
						offset, nVertices, HardwareBuffer::HBU_STATIC_WRITE_ONLY);


					

	
					vbuf->writeData(0, vbuf->getSizeInBytes(), vertices, true);
	

					sub->vertexData->vertexBufferBinding->setBinding(0,vbuf);	
					
					RenderSystem* rs = Root::getSingleton().getRenderSystem();


/////////////////////////////////////////////////Recullo Specular i diffuse de A

					const Ogre::VertexElement* diffuseElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_DIFFUSE);
					ColourValue cv;

					if(dif){
					
					vbuf = vertexData->vertexBufferBinding->getBuffer(diffuseElem->getSource());
					vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
					ARGB* pColour;
		
					vertex = vertex + (vbuf->getVertexSize() * (iVertexA));
		
					diffuseElem->baseVertexPointerToElement(vertex, &pColour);
					ARGB rc = *pColour++;
				
							cv.r = (rc & 0xFF) / 255.0f;		rc >>= 8;
							cv.g = (rc & 0xFF) / 255.0f;		rc >>= 8;
							cv.b = (rc & 0xFF) / 255.0f;		rc >>= 8;
							cv.a = (rc & 0xFF) / 255.0f;
//cv es el color
				
		/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/

		}


					const Ogre::VertexElement* specularElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_SPECULAR);
					ColourValue specular;
					if(spe){
					vbuf = vertexData->vertexBufferBinding->getBuffer(specularElem->getSource());
					vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
					ARGB* pColour;
		
					vertex = vertex + (vbuf->getVertexSize() * (iVertexA));
		
					specularElem->baseVertexPointerToElement(vertex, &pColour);
					ARGB rc = *pColour++;
				
							specular.r = (rc & 0xFF) / 255.0f;		rc >>= 8;
							specular.g = (rc & 0xFF) / 255.0f;		rc >>= 8;
							specular.b = (rc & 0xFF) / 255.0f;		rc >>= 8;
							specular.a = (rc & 0xFF) / 255.0f;	
//specular es el color

		/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
		}

/////////////////////////////////////////////////Recullo Specular i diffuse de B

					if(dif){
					const Ogre::VertexElement* diffuseElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_DIFFUSE);
					ColourValue cv;
					
					vbuf = vertexData->vertexBufferBinding->getBuffer(diffuseElem->getSource());
					vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
					ARGB* pColour;
		
					vertex = vertex + (vbuf->getVertexSize() * (iVertexB));
		
					diffuseElem->baseVertexPointerToElement(vertex, &pColour);
					ARGB rc = *pColour++;
				
							cv.r = (rc & 0xFF) / 255.0f;		rc >>= 8;
							cv.g = (rc & 0xFF) / 255.0f;		rc >>= 8;
							cv.b = (rc & 0xFF) / 255.0f;		rc >>= 8;
							cv.a = (rc & 0xFF) / 255.0f;
//cv es el color
				
		/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/

		}


					specularElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_SPECULAR);
					if(spe){
					vbuf = vertexData->vertexBufferBinding->getBuffer(specularElem->getSource());
					vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
					ARGB* pColour;
		
					vertex = vertex + (vbuf->getVertexSize() * (iVertexB));
		
					specularElem->baseVertexPointerToElement(vertex, &pColour);
					ARGB rc = *pColour++;
				
							specular.r = (rc & 0xFF) / 255.0f;		rc >>= 8;
							specular.g = (rc & 0xFF) / 255.0f;		rc >>= 8;
							specular.b = (rc & 0xFF) / 255.0f;		rc >>= 8;
							specular.a = (rc & 0xFF) / 255.0f;	
//specular es el color

		/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
		}
/////////////////////////////////////////////////Recullo Specular i diffuse de C

					if(dif){
					const Ogre::VertexElement* diffuseElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_DIFFUSE);
					ColourValue cv;
					
					vbuf = vertexData->vertexBufferBinding->getBuffer(diffuseElem->getSource());
					vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
					ARGB* pColour;
		
					vertex = vertex + (vbuf->getVertexSize() * (iVertexC));
		
					diffuseElem->baseVertexPointerToElement(vertex, &pColour);
					ARGB rc = *pColour++;
				
							cv.r = (rc & 0xFF) / 255.0f;		rc >>= 8;
							cv.g = (rc & 0xFF) / 255.0f;		rc >>= 8;
							cv.b = (rc & 0xFF) / 255.0f;		rc >>= 8;
							cv.a = (rc & 0xFF) / 255.0f;

				
		/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/

		}


					specularElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_SPECULAR);

					if(spe){
					vbuf = vertexData->vertexBufferBinding->getBuffer(specularElem->getSource());
					vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
					ARGB* pColour;
		
					vertex = vertex + (vbuf->getVertexSize() * (iVertexC));
		
					specularElem->baseVertexPointerToElement(vertex, &pColour);
					ARGB rc = *pColour++;
				
							specular.r = (rc & 0xFF) / 255.0f;		rc >>= 8;
							specular.g = (rc & 0xFF) / 255.0f;		rc >>= 8;
							specular.b = (rc & 0xFF) / 255.0f;		rc >>= 8;
							specular.a = (rc & 0xFF) / 255.0f;	


		/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
		}


//////////////////////////////////////////////////////////////////////////////

					int nColours = 0;
					if(dif){
						nColours++;}
					if(spe){
						nColours++;}
				RGBA* colour = new RGBA[nVertices*nColours*sizeof(RGBA)];
				RGBA *pColour = colour;
				for(int i=0; i<nVertices; i++){
					if(dif){
						rs->convertColourValue(cv,pColour++);}
					if(spe){
						rs->convertColourValue(specular,pColour++);}	
				}



				offset = 0;
					if(dif){
						decl->addElement(1, offset, VET_COLOUR, VES_DIFFUSE);
						offset += VertexElement::getTypeSize(VET_COLOUR);}
					if(spe){
						decl->addElement(1, offset, VET_COLOUR, VES_SPECULAR);
						offset += VertexElement::getTypeSize(VET_COLOUR);}


				vbuf = HardwareBufferManager::getSingleton().createVertexBuffer(
				offset, nVertices, HardwareBuffer::HBU_STATIC_WRITE_ONLY);

	
				vbuf->writeData(0, vbuf->getSizeInBytes(), colour, true);
				sub->vertexData->vertexBufferBinding->setBinding(1, vbuf);


				unsigned short* faces = new unsigned short[3*sizeof(unsigned short)];
				faces[0] = 0;
				faces[1] = 1;
				faces[2] = 2;



				HardwareIndexBufferSharedPtr inbuf = HardwareBufferManager::getSingleton().
				createIndexBuffer(
				HardwareIndexBuffer::IT_16BIT, 3, HardwareBuffer::HBU_STATIC_WRITE_ONLY);



		
				inbuf->writeData(0, inbuf->getSizeInBytes(), faces, true);
	

				/// Set parameters of the submesh
				sub->useSharedVertices = false;
				sub->indexData->indexBuffer = inbuf;
				sub->indexData->indexCount = 3;
				sub->indexData->indexStart = 0;
		

			/*if (inbuf->isLocked())
						{
							inbuf->unlock();
						}*/


	
			
				delete[] faces;
				delete[] vertices;
				delete[] colour;



/**********************************/
					}else{

						sVertexA = *pShort++; sVertexB = *pShort++; sVertexC = *pShort++;
						
						float *vertices = new float[vbufCount*sizeof(float)];
			///////////////////Recollir posicio vertex A

						const Ogre::VertexElement* positionElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_POSITION);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(positionElem->getSource());
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pPos;

						vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexA));
				
						positionElem->baseVertexPointerToElement(vertex, &pPos);
						vertices[j] = pPos[0];
						j++;
						vertices[j] = pPos[1];
						j++;
						vertices[j] = pPos[2];
						j++;
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/	
			////////////////Recollir normal A

					if(nor){						
						const Ogre::VertexElement* normalElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_NORMAL);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(normalElem->getSource());
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pNor;

						vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexA));
				
						normalElem->baseVertexPointerToElement(vertex, &pNor);
						vertices[j] = pNor[0];
						j++;
						vertices[j] = pNor[1];
						j++;
						vertices[j] = pNor[2];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////Recollir binormal A

					if(bin == true){
						const Ogre::VertexElement* binormalElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_BINORMAL);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(binormalElem->getSource());
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pBin;

						vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexA));
				
						binormalElem->baseVertexPointerToElement(vertex, &pBin);
						vertices[j] = pBin[0];
						j++;
						vertices[j] = pBin[1];
						j++;
						vertices[j] = pBin[2];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
}*/
			////////////////Recollir tangent A
					if(tan){						
						const Ogre::VertexElement* tangentElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_TANGENT);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(tangentElem->getSource());
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pTan;

						vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexA));
				
						tangentElem->baseVertexPointerToElement(vertex, &pTan);
						vertices[j] = pTan[0];
						j++;
						vertices[j] = pTan[1];
						j++;
						vertices[j] = pTan[2];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////Recollir textCoord A

					if(tc){						
						const Ogre::VertexElement* tcElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_TEXTURE_COORDINATES);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(tcElem->getSource());
						//if (vbuf->isLocked()){vbuf->unlock();}
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pTc;

						vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexA));
				
						tcElem->baseVertexPointerToElement(vertex, &pTc);
						vertices[j] = pTc[0];
						j++;
						vertices[j] = pTc[1];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}	*/
			////////////////////////////////////////////////////


			///////////////////Recollir posicio vertex B

						positionElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_POSITION);
						vbuf = vertexData->vertexBufferBinding->getBuffer(positionElem->getSource());
						vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));

						vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexB));
				
						positionElem->baseVertexPointerToElement(vertex, &pPos);
						vertices[j] = pPos[0];
						j++;
						vertices[j] = pPos[1];
						j++;
						vertices[j] = pPos[2];
						j++;
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}		*/	
			////////////////Recollir normal B

					if(nor){						
						const Ogre::VertexElement* normalElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_NORMAL);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(normalElem->getSource());
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pNor;
						vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexB));
				
						normalElem->baseVertexPointerToElement(vertex, &pNor);
						vertices[j] = pNor[0];
						j++;
						vertices[j] = pNor[1];
						j++;
						vertices[j] = pNor[2];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////Recollir binormal B

					if(bin){						
						const Ogre::VertexElement* binormalElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_BINORMAL);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(binormalElem->getSource());
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pBin;
						vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexB));
				
						binormalElem->baseVertexPointerToElement(vertex, &pBin);
						vertices[j] = pBin[0];
						j++;
						vertices[j] = pBin[1];
						j++;
						vertices[j] = pBin[2];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////Recollir tangent B
					if(tan){						
						const Ogre::VertexElement* tangentElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_TANGENT);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(tangentElem->getSource());
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pTan;
						vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexB));
				
						tangentElem->baseVertexPointerToElement(vertex, &pTan);
						vertices[j] = pTan[0];
						j++;
						vertices[j] = pTan[1];
						j++;
						vertices[j] = pTan[2];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////Recollir textCoord B

					if(tc){						
						const Ogre::VertexElement* tcElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_TEXTURE_COORDINATES);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(tcElem->getSource());
						//if (vbuf->isLocked()){vbuf->unlock();}
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pTc;

						vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexB));
				
						tcElem->baseVertexPointerToElement(vertex, &pTc);
						vertices[j] = pTc[0];
						j++;
						vertices[j] = pTc[1];
						j++;
					}

/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////////////////////////////////////////

			///////////////////Recollir posicio vertex C

						positionElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_POSITION);
						vbuf = vertexData->vertexBufferBinding->getBuffer(positionElem->getSource());
						vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						
						vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexC));
				
						positionElem->baseVertexPointerToElement(vertex, &pPos);
						vertices[j] = pPos[0];
						j++;
						vertices[j] = pPos[1];
						j++;
						vertices[j] = pPos[2];
						j++;
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/		
			////////////////Recollir normal C
					if(nor){						
						const Ogre::VertexElement* normalElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_NORMAL);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(normalElem->getSource());
						/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pNor;

						vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexC));
				
						normalElem->baseVertexPointerToElement(vertex, &pNor);
						vertices[j] = pNor[0];
						j++;
						vertices[j] = pNor[1];
						j++;
						vertices[j] = pNor[2];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////Recollir binormal C

					if(bin){						
						const Ogre::VertexElement* binormalElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_BINORMAL);
						/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(binormalElem->getSource());
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pBin;

						vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexC));
				
						binormalElem->baseVertexPointerToElement(vertex, &pBin);
						vertices[j] = pBin[0];
						j++;
						vertices[j] = pBin[1];
						j++;
						vertices[j] = pBin[2];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////Recollir tangent C

					if(tan){						
						const Ogre::VertexElement* tangentElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_TANGENT);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(tangentElem->getSource());
						/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pTan;

						vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexC));
				
						tangentElem->baseVertexPointerToElement(vertex, &pTan);
						vertices[j] = pTan[0];
						j++;
						vertices[j] = pTan[1];
						j++;
						vertices[j] = pTan[2];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////Recollir textCoord C

					if(tc){						
						const Ogre::VertexElement* tcElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_TEXTURE_COORDINATES);
						Ogre::HardwareVertexBufferSharedPtr vbuf = vertexData->vertexBufferBinding->getBuffer(tcElem->getSource());
						/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
						unsigned char* vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
						float* pTc;

						vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexC));
				
						tcElem->baseVertexPointerToElement(vertex, &pTc);
						vertices[j] = pTc[0];
						j++;
						vertices[j] = pTc[1];
						j++;
					}
/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
			////////////////////////////////////////////////////
					sub->vertexData = new VertexData();

					sub->vertexData->vertexStart = 0;
					sub->vertexData->vertexCount = nVertices;

					VertexDeclaration* decl = sub->vertexData->vertexDeclaration;
					size_t offset = 0;

					if(pos){
						decl->addElement(0, offset, VET_FLOAT3, VES_POSITION);
						offset += VertexElement::getTypeSize(VET_FLOAT3);}
					if(nor){
						decl->addElement(0, offset, VET_FLOAT3, VES_NORMAL);
						offset += VertexElement::getTypeSize(VET_FLOAT3);}
					if(bin){
						decl->addElement(0, offset, VET_FLOAT3, VES_BINORMAL);
						offset += VertexElement::getTypeSize(VET_FLOAT3);}
					if(tan){
						decl->addElement(0, offset, VET_FLOAT3, VES_TANGENT);
						offset += VertexElement::getTypeSize(VET_FLOAT3);}
					if(tc){		
						decl->addElement(0, offset, VET_FLOAT2, VES_TEXTURE_COORDINATES);
						offset += VertexElement::getTypeSize(VET_FLOAT2);}

					vbuf = 
						HardwareBufferManager::getSingleton().createVertexBuffer(
						offset, nVertices, HardwareBuffer::HBU_STATIC_WRITE_ONLY);


					

	
					vbuf->writeData(0, vbuf->getSizeInBytes(), vertices, true);
	
	
					sub->vertexData->vertexBufferBinding->setBinding(0,vbuf);	
					
					RenderSystem* rs = Root::getSingleton().getRenderSystem();


/////////////////////////////////////////////////Recullo Specular i diffuse de A

					const Ogre::VertexElement* diffuseElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_DIFFUSE);
					ColourValue cv;

					if(dif){
					
					vbuf = vertexData->vertexBufferBinding->getBuffer(diffuseElem->getSource());
					vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
					ARGB* pColour;
		
					vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexA));
		
					diffuseElem->baseVertexPointerToElement(vertex, &pColour);
					ARGB rc = *pColour++;
				
							cv.r = (rc & 0xFF) / 255.0f;		rc >>= 8;
							cv.g = (rc & 0xFF) / 255.0f;		rc >>= 8;
							cv.b = (rc & 0xFF) / 255.0f;		rc >>= 8;
							cv.a = (rc & 0xFF) / 255.0f;
//cv es el color
				
		/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/

					}


					const Ogre::VertexElement* specularElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_SPECULAR);
					ColourValue specular;
					if(spe){
					vbuf = vertexData->vertexBufferBinding->getBuffer(specularElem->getSource());
					vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
					ARGB* pColour;
		
					vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexA));
		
					specularElem->baseVertexPointerToElement(vertex, &pColour);
					ARGB rc = *pColour++;
				
							specular.r = (rc & 0xFF) / 255.0f;		rc >>= 8;
							specular.g = (rc & 0xFF) / 255.0f;		rc >>= 8;
							specular.b = (rc & 0xFF) / 255.0f;		rc >>= 8;
							specular.a = (rc & 0xFF) / 255.0f;	
//specular es el color

		/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
					}

/////////////////////////////////////////////////Recullo Specular i diffuse de B

					if(dif){
					const Ogre::VertexElement* diffuseElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_DIFFUSE);
					ColourValue cv;
					
					vbuf = vertexData->vertexBufferBinding->getBuffer(diffuseElem->getSource());
					vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
					ARGB* pColour;
		
					vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexB));
		
					diffuseElem->baseVertexPointerToElement(vertex, &pColour);
					ARGB rc = *pColour++;
				
							cv.r = (rc & 0xFF) / 255.0f;		rc >>= 8;
							cv.g = (rc & 0xFF) / 255.0f;		rc >>= 8;
							cv.b = (rc & 0xFF) / 255.0f;		rc >>= 8;
							cv.a = (rc & 0xFF) / 255.0f;
//cv es el color
				
		/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/

					}

					specularElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_SPECULAR);
					if(spe){
					vbuf = vertexData->vertexBufferBinding->getBuffer(specularElem->getSource());
					vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
					ARGB* pColour;
		
					vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexB));
		
					specularElem->baseVertexPointerToElement(vertex, &pColour);
					ARGB rc = *pColour++;
				
							specular.r = (rc & 0xFF) / 255.0f;		rc >>= 8;
							specular.g = (rc & 0xFF) / 255.0f;		rc >>= 8;
							specular.b = (rc & 0xFF) / 255.0f;		rc >>= 8;
							specular.a = (rc & 0xFF) / 255.0f;	
//specular es el color

		/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
					}
/////////////////////////////////////////////////Recullo Specular i diffuse de C

					if(dif){
					const Ogre::VertexElement* diffuseElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_DIFFUSE);
					ColourValue cv;
					
					vbuf = vertexData->vertexBufferBinding->getBuffer(diffuseElem->getSource());
					vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
					ARGB* pColour;
		
					vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexC));
		
					diffuseElem->baseVertexPointerToElement(vertex, &pColour);
					ARGB rc = *pColour++;
				
							cv.r = (rc & 0xFF) / 255.0f;		rc >>= 8;
							cv.g = (rc & 0xFF) / 255.0f;		rc >>= 8;
							cv.b = (rc & 0xFF) / 255.0f;		rc >>= 8;
							cv.a = (rc & 0xFF) / 255.0f;

				
		/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/

					}


					specularElem = vertexData->vertexDeclaration->findElementBySemantic(Ogre::VES_SPECULAR);

					if(spe){
					vbuf = vertexData->vertexBufferBinding->getBuffer(specularElem->getSource());
					vertex = static_cast<unsigned char*>(vbuf->lock(Ogre::HardwareBuffer::HBL_READ_ONLY));
					ARGB* pColour;
		
					vertex = vertex + (vbuf->getVertexSize() * ((int)sVertexC));
		
					specularElem->baseVertexPointerToElement(vertex, &pColour);
					ARGB rc = *pColour++;
				
							specular.r = (rc & 0xFF) / 255.0f;		rc >>= 8;
							specular.g = (rc & 0xFF) / 255.0f;		rc >>= 8;
							specular.b = (rc & 0xFF) / 255.0f;		rc >>= 8;
							specular.a = (rc & 0xFF) / 255.0f;	


		/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
					}

//////////////////////////////////////////////////////////////////////////////

					int nColours = 0;
					if(dif){
						nColours++;}
					if(spe){
						nColours++;}
				RGBA* colour = new RGBA[nVertices*nColours*sizeof(RGBA)];
				RGBA *pColour = colour;
				
				for(int i=0; i<nVertices; i++){
					if(dif){
						rs->convertColourValue(cv,pColour++);}
					if(spe){
						rs->convertColourValue(specular,pColour++);}	
				}



				offset = 0;
					if(dif){
						decl->addElement(1, offset, VET_COLOUR, VES_DIFFUSE);
						offset += VertexElement::getTypeSize(VET_COLOUR);}
					if(spe){
						decl->addElement(1, offset, VET_COLOUR, VES_SPECULAR);
						offset += VertexElement::getTypeSize(VET_COLOUR);}

			if(dif || spe){
				vbuf = HardwareBufferManager::getSingleton().createVertexBuffer(
				offset, nVertices, HardwareBuffer::HBU_STATIC_WRITE_ONLY);
	
				vbuf->writeData(0, vbuf->getSizeInBytes(), colour, true);
				sub->vertexData->vertexBufferBinding->setBinding(1, vbuf);
			}

		/*if (vbuf->isLocked())
						{
							vbuf->unlock();
						}*/
				unsigned short* faces = new unsigned short[3*sizeof(unsigned short)];
				faces[0] = 0;
				faces[1] = 1;
				faces[2] = 2;

//////////////Creem indexs de triangles

				HardwareIndexBufferSharedPtr inbuf = HardwareBufferManager::getSingleton().
				createIndexBuffer(
				HardwareIndexBuffer::IT_16BIT, 3, HardwareBuffer::HBU_STATIC_WRITE_ONLY);



		
				inbuf->writeData(0, inbuf->getSizeInBytes(), faces, true);
	

				/// Set parameters of the submesh
				sub->useSharedVertices = false;
				sub->indexData->indexBuffer = inbuf;
				sub->indexData->indexCount = 3;
				sub->indexData->indexStart = 0;
				//sub->setMaterialName("1 - Default");
				sub->setMaterialName("Proves/Guillem");
		

			/*if (inbuf->isLocked())
						{
							inbuf->unlock();
						}*/


	
			
				delete[] faces;
				delete[] vertices;
				delete[] colour;
		
		msh->load("meshProves");
		Ogre::Mesh* mMesh = msh.getPointer();
		msh.get()->_setBounds(AxisAlignedBox(-50, -50, -50, 50, 50, 50));
		msh.get()->_setBoundingSphereRadius((AxisAlignedBox(-50, -50, -50, 50, 50, 50).getMaximum()-AxisAlignedBox(-50, -50, -50, 50, 50, 50).getMinimum()).length()/2.0);
		//mMesh->_setBounds(AxisAlignedBox(-50, -50, -50, 50, 50, 50));

		string nomEnt = "Entitat";
		Entity * ent;
		char *myBuff = new char[100];
		memset(myBuff,'\0',100);
		itoa(ind,myBuff,10);
		string numEnt = myBuff;
		delete[] myBuff;
		nomEnt.append(numEnt);

		ent = mSceneMgr->createEntity(nomEnt, "meshProves");
		ent->setCastShadows(false);
		ListenerLlums * llista = new ListenerLlums(arbre,mSceneMgr,true);
		//ent->setMaterialName("Proves/Guillem3");
		ent->setVisible(true);
		ent->setListener((MovableObject::Listener*)llista);
		SceneNode * mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		//mNode->setPosition(300,0,0);
			//mNode->yaw(Degree(30));
		mNode->attachObject(ent);
		mNode->showBoundingBox(true);
		llistat.push_back(ent);
		//loadMesh("newMesh2.mesh");
						
						
	}


		}
		}
		}
		
			
		

				
/*
		Ogre::Mesh* mMesh = msh.getPointer();
		Ogre::MeshSerializer* mMeshSeri = new Ogre::MeshSerializer();
		mMesh->_setBounds(AxisAlignedBox(-50, -50, -50, 50, 50, 50));  
		mMeshSeri->exportMesh(mMesh,"C:/newMesh.mesh");

		delete mMeshSeri;	
*/
		return llistat;
	}

	void loadMesh(const String name){
            Entity * ent;
			SceneNode * entNode;

            ent = mSceneMgr->createEntity( name, name );
            entNode = mSceneMgr->getRootSceneNode()->createChildSceneNode( name );
            entNode->attachObject( ent );
            entNode->showBoundingBox(true);
	}



	void afegirObjectes()
	{	
		Entity *ent;
		SceneNode *mNode;
		
		//We create a ground
	/*	Plane plane(Vector3::UNIT_Y, 0);
		MeshManager::getSingleton().createPlane("ground", ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, plane, 700,700,20,20,true,1,5,5,Vector3::UNIT_Z);
        ent = mSceneMgr->createEntity("GroundEntity", "ground");
		ent->setMaterialName("Examples/Rockwall");
        ent->setCastShadows(true);
        mSceneMgr->getRootSceneNode()->createChildSceneNode()->attachObject(ent);

		//We create the roof
		Plane roof(-Vector3::UNIT_Y, 0);
		MeshManager::getSingleton().createPlane("roof", ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, roof, 700,700,20,20,true,1,5,5,Vector3::UNIT_Z);
        ent = mSceneMgr->createEntity("RoofEntity", "roof");
		ent->setMaterialName("Examples/Rockwall");
        ent->setCastShadows(true);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(0,300,0);
		mNode->attachObject(ent);

		//WALLS
		//Front
		Plane plane1(Vector3::UNIT_Z, 0);
		MeshManager::getSingleton().createPlane("wall1",ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, plane1,700,300,20,20,true,1,5,5,-Vector3::UNIT_Y);
		ent = mSceneMgr->createEntity("Wall1Entity", "wall1");
		ent->setMaterialName("Examples/Rockwall");
		ent->setCastShadows(true);
		mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(0,150,-350);
		mNode->attachObject(ent);

		//Back
		Plane plane2(-Vector3::UNIT_Z, 0);
		MeshManager::getSingleton().createPlane("wall2",ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, plane2,700,300,20,20,true,1,5,5,Vector3::UNIT_Y);
		ent = mSceneMgr->createEntity("Wall2Entity", "wall2");
		ent->setMaterialName("Examples/Rockwall");
		ent->setCastShadows(true);
		mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(0,150,350);
		mNode->attachObject(ent);

		//Left
		Plane plane3(Vector3::UNIT_X, 0);
		MeshManager::getSingleton().createPlane("wall3",ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, plane3,700,300,20,20,true,1,5,5,Vector3::UNIT_Y);
		ent = mSceneMgr->createEntity("Wall3Entity", "wall3");
		ent->setMaterialName("Examples/Rockwall");
		ent->setCastShadows(true);
		mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(-350,150,0);
		mNode->attachObject(ent);

		//Right
		Plane plane4(-Vector3::UNIT_X, 0);
		MeshManager::getSingleton().createPlane("wall4",ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, plane4,700,300,20,20,true,1,5,5,Vector3::UNIT_Y);
		ent = mSceneMgr->createEntity("Wall4Entity", "wall4");
		ent->setMaterialName("Examples/Rockwall");
		ent->setCastShadows(true);
		mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(350,150,0);
		mNode->attachObject(ent);
        
        //SCENE
		//We create a ninja
		ent = mSceneMgr->createEntity("Ninja", "ninja.mesh");
        ent->setCastShadows(true);
        mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->yaw(Degree(180));
		mNode->setPosition(100,0,0);
		mNode->attachObject(ent);*/

		//We create an ogre head
	/*	ent = mSceneMgr->createEntity("OgreHead", "cube.mesh");
		ent->setCastShadows(false);
		mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(10,85,50);
		mNode->yaw(Degree(30));
		mNode->attachObject(ent);
		std::deque<Entity*> llistaEntitats = separaTriangles(ent->getMesh());
		cout << "tamany llista entitats: " << llistaEntitats.size() << "________---------_______" << endl;*/

		//We create an ogre head separat
		/*ent = mSceneMgr->createEntity("Fish_separat", "fish_separat.mesh");
		ent->setCastShadows(false);
		typedef std::vector<SubMesh*> SubMeshList;
		typedef VectorIterator<SubMeshList> SubMeshIterator;
		SubMeshIterator asd = ent->getMesh()->getSubMeshIterator();
		int nelements = 0;
		while (asd.hasMoreElements()) {
			asd.getNext();
			nelements++;
		}
		cout << endl << "EEEEEEEEEEEEEEEEEEEEEEEEEEEEE nombre submeshes: " << nelements << endl << endl;
		mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(-210,0,0);
		mNode->yaw(Degree(30));
		mNode->attachObject(ent);*/
/*
		//We create a barrel
		ent = mSceneMgr->createEntity("Barrel", "Barrel.mesh");
		ent->setCastShadows(true);
		mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(10,30,50);
		mNode->scale(10,10,10);
		mNode->attachObject(ent);

		//We create a wood pallet
		ent = mSceneMgr->createEntity("WoodPallet", "WoodPallet.mesh");
		ent->setCastShadows(true);
		mNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
		mNode->setPosition(-48,35,65);
		mNode->scale(12,12,12);
		mNode->yaw(Degree(25));
		mNode->roll(Degree(45));
		mNode->attachObject(ent);*/
    }

	
};

#if OGRE_PLATFORM == PLATFORM_WIN32 || OGRE_PLATFORM == OGRE_PLATFORM_WIN32
#define WIN32_LEAN_AND_MEAN
#include "windows.h"

INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR strCmdLine, INT )
#else
int main(int argc, char **argv)
#endif
{
    // Create application object
    TutorialApplication app;
	showWin32Console();

    try {
        app.go();
    } catch(Exception& e) {
#if OGRE_PLATFORM == PLATFORM_WIN32 || OGRE_PLATFORM == OGRE_PLATFORM_WIN32
        MessageBox(NULL, e.getFullDescription().c_str(), "An exception has occurred!", MB_OK | MB_ICONERROR | MB_TASKMODAL);
#else
        fprintf(stderr, "An exception has occurred: %s\n",
            e.getFullDescription().c_str());
#endif
    }
	FreeConsole();
    return 0;
}